<?
/* 
 * EDOMI beta (Version 1.52) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
//Globale Includes
require("../../shared/php/config.php");
require(MAIN_PATH."/www/shared/php/base.php");
require(MAIN_PATH."/www/shared/php/incl_http.php");

//Eigene Includes
require(MAIN_PATH."/www/admin/include/php/config.php");
require(MAIN_PATH."/www/admin/include/php/base.php");


sql_connect();

if (checkAdmin($sid)) {cmd($cmd);}

function cmd($cmd) {
	global $appId,$winId,$data,$dataArr,$phpdata,$phpdataArr,$sid;
	global $global_weekdays;

	if ($cmd=='initApp') {
		//Hilfe
		$help='';
		$tmp=sql_getValues('edomiProject.editLogicElement','functionid','id='.$phpdataArr[0]);
		if ($tmp!==false) {$help=ajaxValueHTML(helpToHtml($winId,'lbs_'.$tmp['functionid'],true));}
		if (isEmpty($help)) {$help="Für diesen Logikbaustein ist keine Hilfe verfügbar.";}
		
		//Fenster aufbauen
?>
		var n="<div class='appWindowNormal'>";
			n+="<div class='appTitel'>Hilfe (Logikbaustein-Instanz)<div class='cmdHelp' onClick='openWindow(9999,\"<?echo $appId;?>\");'>?</div></div>";
			n+="<div id='<?echo $winId;?>-main'>";
				n+="<div id='<?echo $winId;?>-form1' class='appMenu'>";
					n+="<div class='cmdButton' onClick='closeWindow(\"<?echo $winId;?>\");'>Schliessen</div>&nbsp;&nbsp;&nbsp;";
					n+="<div class='cmdButton' onClick='window.open(\"help.php?file=lbs_<?echo $tmp['functionid'];?>\",\"_blank\");' style='float:right; min-width:auto; width:30px;'>&#x21D7;</div>";
				n+="</div>";
				n+="<table width='100%' border='0' cellpadding='0' cellspacing='0' style='table-layout:auto;'>";
					n+="<tr>";
						n+="<td valign='top'><div id='<?echo $winId;?>-info2' class='controlEditInline' style='padding:0; margin:0 10px 0 0; width:150px; height:470px; text-align:left; background:#e8e800;'></div></td>";
						n+="<td valign='top' rowspan='2'><div id='<?echo $winId;?>-info' class='controlEditInline' style='padding:0; width:700px; height:500px; background:#ffffff; border-radius:0; border:0; padding:0;'><?echo $help;?></div></td>";
					n+="</tr>";
					n+="<tr>";
						n+="<td valign='bottom'><div id='<?echo $winId;?>-refresh' class='cmdButton' onClick='ajax(\"liveVars\",\"<?echo $appId;?>\",\"<?echo $winId;?>\",\"<?echo $data;?>\",\"<?echo $phpdata;?>\");' style='width:152px;'>Aktualisieren</div></td>";
					n+="</tr>";
				n+="</table>";
			n+="</div>";
		n+="</div>";
		document.getElementById("<?echo $winId;?>").innerHTML=n;
<?
		cmd('liveVars');
	}

	if ($cmd=='liveVars') {
		//Live-Daten (Baustein-Variablen)
?>
		document.getElementById("<?echo $winId;?>-info2").style.display="none";
		document.getElementById("<?echo $winId;?>-refresh").style.display="none";
<?
		if (checkLiveProjectData()) {
			//Baustein-Status
			$ss1=sql_call("SELECT status FROM edomiLive.RAMlogicElement WHERE (id=".$phpdataArr[0].")");
			if ($n=sql_result($ss1)) {
?>
				var n='<table style="width:100%; white-space:nowrap; table-layout:auto;" border="0" cellpadding="2" cellspacing="0">';
				n+='<tr bgcolor="#bbbb00">';
					n+='<td colspan="3">Status</td>';
				n+='</tr>';
					n+='<tr>';
<?
				if ($n['status']==1) {
?>
						n+='<td colspan="3" style="color:#ffffff; background:#ff0000;">zyklisch</td>';
<?
				} else if ($n['status']>1) {
?>
						n+='<td colspan="3" style="color:#ffffff; background:#ff0000;">zyklisch (<?echo $n['status'];?> ms)</td>';
<?
				} else {
?>
						n+='<td colspan="3" style="color:#909000;">inaktiv</td>';
<?
				}
?>
					n+='</tr>';

				n+='<tr bgcolor="#bbbb00">';
					n+='<td colspan="3">Eingänge</td>';
				n+='</tr>';
<?
				//LBS-Eingänge
				$ss2=sql_call("SELECT eingang,value FROM edomiLive.RAMlogicLink WHERE (elementid=".$phpdataArr[0].") ORDER BY eingang ASC");
				while ($nn=sql_result($ss2)) {
?>
					n+='<tr>';
						n+='<td>E<?echo $nn['eingang'];?></td>';
						n+='<td>=</td>';
						n+='<td><?ajaxEcho($nn['value']);?></td>';
					n+='</tr>';
<?
				}
?>
				n+='<tr bgcolor="#bbbb00">';
					n+='<td colspan="3">Variablen</td>';
				n+='</tr>';
<?
				//LBS-Variablen
				$ss2=sql_call("SELECT varid,value FROM edomiLive.RAMlogicElementVar WHERE (elementid=".$phpdataArr[0].") ORDER BY varid ASC");
				while ($nn=sql_result($ss2)) {
?>
					n+='<tr>';
						n+='<td>V<?echo $nn['varid'];?></td>';
						n+='<td>=</td>';
						n+='<td><?ajaxEcho($nn['value']);?></td>';
					n+='</tr>';
<?
				}
?>
				n+='<tr bgcolor="#bbbb00">';
					n+='<td colspan="3">Ausgänge (nur belegte)</td>';
				n+='</tr>';
<?
				//LBS-Ausgänge
				$ss2=sql_call("SELECT DISTINCT(ausgang),value FROM edomiLive.RAMlogicLink WHERE (linktyp=1 AND linkid=".$phpdataArr[0].") ORDER BY ausgang ASC");
				while ($nn=sql_result($ss2)) {
?>
					n+='<tr>';
						n+='<td>A<?echo $nn['ausgang'];?></td>';
						n+='<td>=</td>';
						n+='<td><?ajaxEcho($nn['value']);?></td>';
					n+='</tr>';
<?
				}
?>
				n+='<tr>';
					n+='<td width="1">&nbsp;</td>';
					n+='<td width="1">&nbsp;</td>';
					n+='<td>&nbsp;</td>';
				n+='</tr>';
				n+='</table>';
				document.getElementById("<?echo $winId;?>-info2").innerHTML=n;
				document.getElementById("<?echo $winId;?>-info2").style.display="inline-block";
				document.getElementById("<?echo $winId;?>-refresh").style.display="inline-block";
<?
			}
		}
	}


}

sql_disconnect();
?>

