/* 
 * EDOMI beta (Version 1.52) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 1 (Universalelement)
//----------------------------

function control1_constructControl(obj,item) {
	var n="<table cellpadding='0' cellspacing='0' border='0' style='left:0; top:0; width:100%; height:100%; pointer-events:none;'>";
		n+="<tr><td><span id='e-"+item.id+"-text'></span></td></tr>";
	n+="</table>";
	obj.innerHTML=n;

	if (obj.dataset.var0==1) {
		if (obj.dataset.var1==0) { 
			//Normaler Klick
			obj.addEventListener(downEvent,function(){if (!checkClick()){return;} visuElementClick(item.id,((obj.dataset.var2>=2)?true:false));},false); 
		} else {
			//Langer Klick
			obj.addEventListener(downEvent,function(){if (!checkClick()){return;} control1_LongClickStart(item.id);},false);
			obj.addEventListener(upEvent,function(){control1_LongClickCancel(item.id);},false);
		}
	}
}

function control1_refreshControl(obj,design,init) {
	document.getElementById("e-"+design.elementid+"-text").innerHTML=pS(design.text,design.kovalue);
}


function control1_LongClickStart(elementId) {
	var obj=document.getElementById("e-"+elementId);
	clickTimer=window.setTimeout("control1_LongClickSend('"+elementId+"');",1000);
	if (obj.dataset.var2!=1 && obj.dataset.var2!=3) {
		if (!event) {var event=window.event;}
		var d=document.getElementById("longclick");
		d.style.display="inline";
		d.style.borderColor=visu_indiColor;
		d.style.borderTopColor=visu_indiColorText;
		
//### alte Version (bis 1.44)
//		d.style.left=parseInt(getPageX(event)-(d.offsetWidth/2))+'px';
//		d.style.top=parseInt(getPageY(event)-(d.offsetHeight/2))+'px';

//neue Version (ab 1.45)
		var tmp=obj.getBoundingClientRect();
		if (tmp.width>tmp.height) {var w=tmp.height;} else {var w=tmp.width;}
		d.style.width=(w-6)+'px';
		d.style.height=(w-6)+'px';
		var x=parseFloat((tmp.left+window.scrollX)+tmp.width/2)-(w/2);
		var y=parseFloat((tmp.top+window.scrollY)+tmp.height/2)-(w/2);
		d.style.left=x+'px';
		d.style.top=y+'px';

	}
}

function control1_LongClickSend(elementId) {
	var obj=document.getElementById("e-"+elementId);
	var d=document.getElementById("longclick");
	if (d) {d.style.display="none";}
	visuElementClick(elementId,((obj.dataset.var2>=2)?true:false));
}

function control1_LongClickCancel(elementId) {
	clearTimeout(clickTimer);
	var d=document.getElementById("longclick");
	if (d) {d.style.display="none";}
}
