/* 
 * EDOMI beta (Version 1.52) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 11 (Drehregler)
//----------------------------

function control11_constructControl(obj,item) {
	var n="<table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%; pointer-events:none;'>";
		n+="<tr><td><span id='e-"+item.id+"-text'></span></td></tr>";
	n+="</table>";
	n+="<div id='e-"+item.id+"-edit' style='display:none; position:absolute; left:0; top:0; right:0; bottom:0; color:"+visu_indiColorText+"; pointer-events:none;'></div>";
	if (obj.dataset.var1==0) {
		//neutral
		n+="<div id='e-"+item.id+"-editrotateobj' style='display:none; position:absolute; left:0; top:0;'><div style='display:block; margin-left:auto; margin-right:auto; width:3px; height:15%; background:"+visu_indiColor+";'></div></div>";
	} else if (obj.dataset.var1==1) {
		//Ring anzeigen
		n+="<div id='e-"+item.id+"-wheel0outline' style='position:absolute; left:0; top:0; border:1px solid; border-radius:100%; background:transparent;'></div>";
		n+="<div id='e-"+item.id+"-editrotateobj' style='display:none; position:absolute; left:0; top:0;'><div style='display:block; margin-left:auto; margin-right:auto; width:3px; height:15%; background:"+visu_indiColor+";'></div></div>";
	}
	obj.innerHTML=n;

	obj.addEventListener(downEvent,function(){if (!checkClick()){return;} control11_Start(item.id);},false);
}

function control11_refreshControl(obj,design,init) {
	obj.dataset.blocked=0;
	obj.dataset.caption=design.caption;
	document.getElementById("e-"+design.elementid+"-text").innerHTML=pS(design.text,design.kovalue);
	control11_Init(design.elementid,design.kovalue);
}


function control11_Init(elementId,koValue) {
	//wheel0outline skalieren, falls vorhanden
	var d=document.getElementById("e-"+elementId);
	if (d.dataset.var1==1) {
		var objOutline=document.getElementById("e-"+elementId+"-wheel0outline");
		if (objOutline) {
			var w=parseInt(d.style.width.replace("px",""));
			var h=parseInt(d.style.height.replace("px",""));
			var newSize=w;
			if (w>=h) {var newSize=h;}
			newSize-=2;
	
			objOutline.style.left=(w/2-(newSize-2)/2-1)+"px";
			objOutline.style.top=(h/2-(newSize-2)/2-1)+"px";
			objOutline.style.width=((newSize-2))+"px";
			objOutline.style.height=((newSize-2))+"px";
		}
	}
}

function control11_Start(elementId) {
	if (!event) var event=window.event;
	var d=document.getElementById("e-"+elementId);
	if (d.dataset.blocked==1) {return;}

	elementDragId=elementId;

	document.getElementById("e-"+elementId+"-text").style.display="none";
	document.getElementById("e-"+elementId+"-edit").style.display="inline";
	document.getElementById("e-"+elementId+"-editrotateobj").style.display="inline";

	if (d.dataset.var1==1) {
		createWheel(d,document.getElementById("e-"+elementId+"-editrotateobj"),-4);
	} else {
		createWheel(d,document.getElementById("e-"+elementId+"-editrotateobj"),-2);
	}

	d.dataset.oldangle="";
	d.dataset.editvalue=d.dataset.value;
	if (d.dataset.editvalue=="") {d.dataset.editvalue=0;}
	control11_Move();

	window.addEventListener(moveEvent,control11_Move,false);
	window.addEventListener(upEvent,control11_Send,false);

	if (visu_allowScrolling) {
		//Scrolling temporär verhindern
		window.addEventListener(moveEvent,disableScrolling,false);
	}

}

function control11_Move() {
	if (!event) var event=window.event;
	if (elementDragId>0) {
		var d=document.getElementById("e-"+elementDragId);
		if (d && d.dataset.controltyp==11) {

			var vmin=parseFloat(d.dataset.var5);
			var vmax=parseFloat(d.dataset.var6);
			var vstep=parseFloat(d.dataset.var7); if (isNaN(vstep)) {vstep=1;}
			var vlist=parseInt(d.dataset.var8); if (isNaN(vlist) || vlist<0) {vlist=0;}

			var x1=parseInt(document.getElementById("windowContainer").offsetLeft+d.offsetLeft+(d.offsetWidth/2))+parseInt(d.dataset.pagex); //Mittelpunkt des Elements
			var y1=parseInt(document.getElementById("windowContainer").offsetTop+d.offsetTop+(d.offsetHeight/2))+parseInt(d.dataset.pagey);
			var x2=getPageX(event);
			var y2=getPageY(event);

			var angle=Math.atan2(x2-x1,y2-y1)*180/Math.PI;
			if (d.dataset.oldangle=="") {
				var relAngle=0;
			} else {
				var relAngle=d.dataset.oldangle-angle;
				if (Math.abs(relAngle)>50) {relAngle=0;}
			}
			d.dataset.oldangle=angle;

			var sense=(Math.abs(vmax-vmin)/vstep)/360;
			if (isNaN(sense)) {sense=1;}
			if (sense>1) {sense=1;}
			var tmp=parseFloat(parseFloat(d.dataset.editvalue)+(vstep*relAngle*sense));

			if (tmp<vmin && !isNaN(vmin)) {tmp=vmin;}
			if (tmp>vmax && !isNaN(vmax)) {tmp=vmax;}

			d.dataset.editvalue=tmp;	//Float! (ohne vstep+vlist)
			if (isNaN(tmp)) {
				document.getElementById("e-"+elementDragId+"-edit").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>?</span></button>";
			} else {
				var n=parseInt(tmp/vstep)*vstep;
				document.getElementById("e-"+elementDragId+"-edit").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+pS(d.dataset.caption,n.toFixed(vlist))+"</span></button>";
			}
			document.getElementById("e-"+elementDragId+"-editrotateobj").style.WebkitTransform="rotate("+parseFloat((360-(angle+180)))+"deg)";
		}
	}
}

function control11_Send() {
	var d=document.getElementById("e-"+elementDragId);
	if (d && d.dataset.controltyp==11) {

		var vstep=parseFloat(d.dataset.var7); if (isNaN(vstep)) {vstep=1;}
		var vlist=parseInt(d.dataset.var8); if (isNaN(vlist) || vlist<0) {vlist=0;}
		var n=parseInt(d.dataset.editvalue/vstep)*vstep;
		var newValue=n.toFixed(vlist);

		var setKoMode=d.dataset.var4;
		var setKoChanged=false;
		if (parseFloat(d.dataset.value)!==parseFloat(newValue)) {setKoChanged=true;}
		if ((setKoMode==0) || (setKoMode==1 && setKoChanged) || (setKoMode==2) || (setKoMode==3 && setKoChanged)) {
			if ((setKoMode==2) || (setKoMode==3 && setKoChanged)) {
				d.dataset.blocked=0;
			} else {
				d.dataset.blocked=1;
				document.getElementById("e-"+elementDragId+"-text").innerHTML="<div class='sendValueAnim'>"+document.getElementById("e-"+elementDragId+"-edit").innerHTML+"</div>";
			}
			setKoValue(d.dataset.gaid2,newValue);
		}

		document.getElementById("e-"+elementDragId+"-text").style.display="inline";
		document.getElementById("e-"+elementDragId+"-edit").style.display="none";
		document.getElementById("e-"+elementDragId+"-editrotateobj").style.display="none";

		elementDragId=0;
		window.removeEventListener(moveEvent,control11_Move,false);
		window.removeEventListener(upEvent,control11_Send,false);

		if (visu_allowScrolling) {
			//Scrolling wieder freigeben
			window.removeEventListener(moveEvent,disableScrolling,false);
		}

	}
}
