/* 
 * EDOMI beta (Version 1.52) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 12 (Dimmer/RGB/HSV)
//----------------------------

function control12_constructControl(obj,item) {	
	if (obj.dataset.var1==0) { 
		//Dimmer
		var n="<table cellpadding='0' cellspacing='0' width='100%' height='100%' border='0'>";
			n+="<tr valign='top'>";
				n+="<td align='left' style='"+((obj.dataset.var3 & 1)?"border-right:1px solid; border-bottom:1px solid;":"")+"padding-left:5%; padding-top:5%; width:50%;'>&nbsp;</td>";
				n+="<td align='right' style='"+((obj.dataset.var3 & 1)?"border-bottom:1px solid;":"")+"padding-right:5%; padding-top:5%; width:50%;'>&nbsp;</td>";
			n+="</tr>";
			n+="<tr valign='bottom'>";
				n+="<td id='e-"+item.id+"-off' align='left' style='"+((obj.dataset.var3 & 1)?"border-right:1px solid;":"")+"padding-left:5%; padding-bottom:5%; width:50%;'>aus</td>";
				n+="<td id='e-"+item.id+"-on' align='right' style='padding-right:5%; padding-bottom:5%; width:50%;'>ein</td>";
			n+="</tr>";
		n+="</table>";

		if (obj.dataset.var3 & 2) {n+="<div id='e-"+item.id+"-wheel0outline' style='position:absolute; left:0; top:0; border:1px solid; border-radius:100%; background:transparent;'></div>";}
		n+="<div id='e-"+item.id+"-wheel0' style='position:absolute; left:0; top:0; border:3px solid #000000; border-radius:100%; background:inherit;'>";
			n+="<div id='e-"+item.id+"-editrotateobj' style='display:none; position:absolute; left:0; top:0;'><div style='display:block; margin-left:auto; margin-right:auto; width:3px; height:15%; background:"+visu_indiColor+";'></div></div>";
		n+="</div>";
		n+="<div id='e-"+item.id+"-level' style='display:none; position:absolute; left:0; top:0; right:0; bottom:0; pointer-events:none;'>";
			n+="<div id='e-"+item.id+"-bar' style='position:absolute; left:0; top:0; border:3px solid; border-left-color:transparent; border-bottom-color:transparent; border-radius:100%; background:none; pointer-events:none;'></div>";
		n+="</div>";
		n+="<div style='position:absolute; left:0; top:0; right:0; bottom:0; pointer-events:none;'><table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%;'><tr><td><span id='e-"+item.id+"-text'></span></td></tr></table></div>";
		n+="<div id='e-"+item.id+"-edit' style='display:none; position:absolute; left:0; top:0; right:0; bottom:0; color:"+visu_indiColorText+"; pointer-events:none;'></div>";
		obj.innerHTML=n;

		document.getElementById("e-"+item.id+"-wheel0").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,0);},false);
		document.getElementById("e-"+item.id+"-off").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Switch(item.id,0);},false);
		document.getElementById("e-"+item.id+"-on").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Switch(item.id,1);},false);

	} else if (obj.dataset.var1==1) {
		//RGB-Dimmer
		var n="<table cellpadding='0' cellspacing='0' width='100%' height='100%' border='0'>";
			n+="<tr valign='top'>";
				n+="<td id='e-"+item.id+"-wheel1' align='left' style='"+((obj.dataset.var3 & 1)?"border-right:1px solid; border-bottom:1px solid;":"")+"padding-left:5%; padding-top:5%; width:50%;'>R</td>";
				n+="<td id='e-"+item.id+"-wheel2' align='right' style='"+((obj.dataset.var3 & 1)?"border-bottom:1px solid;":"")+"padding-right:5%; padding-top:5%; width:50%;'>G</td>";
			n+="</tr>";
			n+="<tr valign='bottom'>";
				n+="<td id='e-"+item.id+"-off' align='left' style='"+((obj.dataset.var3 & 1)?"border-right:1px solid;":"")+"padding-left:5%; padding-bottom:5%; width:50%;'>aus</td>";
				n+="<td id='e-"+item.id+"-wheel3' align='right' style='padding-right:5%; padding-bottom:5%; width:50%;'>B</td>";
			n+="</tr>";
		n+="</table>";

		if (obj.dataset.var3 & 2) {n+="<div id='e-"+item.id+"-wheel0outline' style='position:absolute; left:0; top:0; border:1px solid; border-radius:100%; background:transparent;'></div>";}
		n+="<div id='e-"+item.id+"-wheel0' style='position:absolute; left:0; top:0; border:3px solid #000000; border-radius:100%; background:inherit;'>";
			n+="<div id='e-"+item.id+"-editrotateobj' style='display:none; position:absolute; left:0; top:0;'><div style='display:block; margin-left:auto; margin-right:auto; width:3px; height:15%; background:"+visu_indiColor+";'></div></div>";
		n+="</div>";
		n+="<div id='e-"+item.id+"-level' style='display:none; position:absolute; left:0; top:0; right:0; bottom:0; pointer-events:none;'>";
			n+="<div id='e-"+item.id+"-bar' style='position:absolute; left:0; top:0; border:3px solid; border-left-color:transparent; border-bottom-color:transparent; border-radius:100%; background:none; pointer-events:none;'></div>";
		n+="</div>";
		n+="<div style='position:absolute; left:0; top:0; right:0; bottom:0; pointer-events:none;'><table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%;'><tr><td><span id='e-"+item.id+"-text'></span></td></tr></table></div>";
		n+="<div id='e-"+item.id+"-edit' style='display:none; position:absolute; left:0; top:0; right:0; bottom:0; color:"+visu_indiColorText+"; pointer-events:none;'></div>";
		obj.innerHTML=n;

		document.getElementById("e-"+item.id+"-wheel0").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,0);},false);
		document.getElementById("e-"+item.id+"-wheel1").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,1);},false);
		document.getElementById("e-"+item.id+"-wheel2").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,2);},false);
		document.getElementById("e-"+item.id+"-wheel3").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,3);},false);
		document.getElementById("e-"+item.id+"-off").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Switch(item.id,0);},false);

	} else if (obj.dataset.var1==2) {
		//HSV-Dimmer
		var n="<table cellpadding='0' cellspacing='0' width='100%' height='100%' border='0'>";
			n+="<tr valign='top'>";
				n+="<td id='e-"+item.id+"-wheel1' align='left' style='"+((obj.dataset.var3 & 1)?"border-right:1px solid; border-bottom:1px solid;":"")+"padding-left:5%; padding-top:5%; width:50%;'>H</td>";
				n+="<td id='e-"+item.id+"-wheel2' align='right' style='"+((obj.dataset.var3 & 1)?"border-bottom:1px solid;":"")+"padding-right:5%; padding-top:5%; width:50%;'>S</td>";
			n+="</tr>";
			n+="<tr valign='bottom'>";
				n+="<td id='e-"+item.id+"-off' align='left' style='"+((obj.dataset.var3 & 1)?"border-right:1px solid;":"")+"padding-left:5%; padding-bottom:5%; width:50%;'>aus</td>";
				n+="<td id='e-"+item.id+"-on' align='right' style='padding-right:5%; padding-bottom:5%; width:50%;'>ein</td>";
			n+="</tr>";
		n+="</table>";
		
		if (obj.dataset.var3 & 2) {n+="<div id='e-"+item.id+"-wheel0outline' style='position:absolute; left:0; top:0; border:1px solid; border-radius:100%; background:transparent;'></div>";}
		n+="<div id='e-"+item.id+"-wheel0' style='position:absolute; left:0; top:0; border:3px solid #000000; border-radius:100%; background:inherit;'>";
			n+="<div id='e-"+item.id+"-editrotateobj' style='display:none; position:absolute; left:0; top:0;'><div style='display:block; margin-left:auto; margin-right:auto; width:3px; height:15%; background:"+visu_indiColor+";'></div></div>";
		n+="</div>";
		n+="<div id='e-"+item.id+"-level' style='display:none; position:absolute; left:0; top:0; right:0; bottom:0; pointer-events:none;'>";
			n+="<div id='e-"+item.id+"-bar' style='position:absolute; left:0; top:0; border:3px solid; border-left-color:transparent; border-bottom-color:transparent; border-radius:100%; background:none; pointer-events:none;'></div>";
		n+="</div>";
		n+="<div style='position:absolute; left:0; top:0; right:0; bottom:0; pointer-events:none;'><table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%;'><tr><td><span id='e-"+item.id+"-text'></span></td></tr></table></div>";
		n+="<div id='e-"+item.id+"-edit' style='display:none; position:absolute; left:0; top:0; right:0; bottom:0; color:"+visu_indiColorText+"; pointer-events:none;'></div>";
		obj.innerHTML=n;

		document.getElementById("e-"+item.id+"-wheel0").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,0);},false);
		document.getElementById("e-"+item.id+"-wheel1").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,1);},false);
		document.getElementById("e-"+item.id+"-wheel2").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,2);},false);
		document.getElementById("e-"+item.id+"-off").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Switch(item.id,0);},false);
		document.getElementById("e-"+item.id+"-on").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Switch(item.id,1);},false);
	}
}

function control12_refreshControl(obj,design,init) {
	obj.dataset.blocked=0;
	document.getElementById("e-"+design.elementid+"-text").innerHTML=pS(design.text,design.kovalue);
	control12_Init(design.elementid,design.kovalue);
}

function control12_Init(elementId,koValue) {
	var d=document.getElementById("e-"+elementId);
	var obj=document.getElementById("e-"+elementId+"-wheel0");
	var objLevel=document.getElementById("e-"+elementId+"-level");
	var objBar=document.getElementById("e-"+elementId+"-bar");
	var w=parseInt(d.style.width.replace("px",""));
	var h=parseInt(d.style.height.replace("px",""));

	function ringStatus(elementId,ringColor,ringValue,lightSize) {
		//rendert den Farbring und die Helligkeitsskala
		//ringColor: Farbwert des Farbrings (z.B. "A1B2C3"), false=Farbwert ist ungültig (d.h. Lampe ist aus)
		//ringValue: %-Wert (0..100) der Helligkeit für die Skala
		//lightSize: Größe des Leuchtrings (falls vorhanden)
		if (ringColor!==false && ringValue>0) {
			var rgba=RGBHEXtoRGBA(ringColor);
			obj.style.borderColor="rgba("+rgba[0]+","+rgba[1]+","+rgba[2]+","+rgba[3]+")";
			if (d.dataset.var3 & 4) {
				obj.style.boxShadow="0 0 "+(lightSize/2)+"px "+(lightSize/2)+"px rgba("+rgba[0]+","+rgba[1]+","+rgba[2]+","+rgba[3]+")";
			}
			//Level-Bar
			if (d.dataset.var2>0) {
				objLevel.style.display="inline";
				var angle=-225+(ringValue*(180/100));
				if (angle<-225) {angle=-225;}
				if (angle>-45) {angle=-45;}
				objBar.style.webkitTransform="rotate("+angle+"deg)";
				if (d.dataset.var2==1) {
					//Normal
					objLevel.style.clip="rect(0px,"+w+"px,"+(h/2)+"px,0px)";
				}
				if (d.dataset.var2==2) {
					//Invertiert
					objLevel.style.clip="rect("+(h/2)+"px,"+w+"px,"+h+"px,0px)";
				}
			}
		} else {
			obj.style.borderColor="transparent";
			if (d.dataset.var3 & 4) {
				obj.style.boxShadow="none";
			}
			objLevel.style.display="none";
		}
	}

	//Wheel-Container anpassen
	var newSize=w;
	var p=newSize*5/100; //Padding (5%)
	if (w>=h) {var newSize=h;}
	obj.style.left=(p+w/2-newSize/2)+"px";
	obj.style.top=(p+h/2-newSize/2)+"px";
	obj.style.width=(newSize-(2*3)-(2*p))+"px"; //-(2*3) wegen Border
	obj.style.height=(newSize-(2*3)-(2*p))+"px";

	//Levelskala anpassen
	objBar.style.left=(p+w/2-newSize/2)+"px";
	objBar.style.top=(p+h/2-newSize/2)+"px";
	objBar.style.width=(newSize-(2*3)-(2*p))+"px"; //-(2*3) wegen Border
	objBar.style.height=(newSize-(2*3)-(2*p))+"px";

	//wheel0: Hintergrund positionieren und skalieren
	obj.style.backgroundSize=d.style.width+" "+d.style.height;
	obj.style.backgroundPosition="-"+parseInt(parseInt(obj.style.left.replace("px",""))+3)+"px -"+parseInt(parseInt(obj.style.top.replace("px",""))+3)+"px";

	//wheel0outline skalieren, falls vorhanden
	if (d.dataset.var3 & 2) {
		var objOutline=document.getElementById("e-"+elementId+"-wheel0outline");
		if (objOutline) {
			objOutline.style.left=(p+w/2-newSize/2-1)+"px";
			objOutline.style.top=(p+h/2-newSize/2-1)+"px";
			objOutline.style.width=(newSize-(2*p))+"px"; //-(2*3) wegen Border
			objOutline.style.height=(newSize-(2*p))+"px";
		}
	}
	
	//aktuelle Farbe/Helligkeit anzeigen
	if (d.dataset.var1==0) { //Dimmer
		ringStatus(elementId,RGBtoRGBHEX(koValue,koValue,koValue),koValue/2.55,p);
	}
	if (d.dataset.var1==1) { //RGB-Dimmer
		var hsv=RGBHEXtoHSV(koValue);
		if (hsv!==false) {ringColor=koValue;} else {ringColor=false;}
		ringStatus(elementId,ringColor,hsv[2]/2.55,p);
	}
	if (d.dataset.var1==2) { //HSV-Dimmer
		var hsv=HSVHEXtoHSV(koValue);
		if (hsv!==false) {ringColor=HSVtoRGBHEX(hsv[0],hsv[1],hsv[2]);} else {ringColor=false;}
		ringStatus(elementId,ringColor,hsv[2]/2.55,p);
	}
}

function control12_Start(elementId,wheelId) {
	if (!event) var event=window.event;
	var d=document.getElementById("e-"+elementId);
	if (d.dataset.blocked==1) {return;}

	elementDragId=elementId;

	document.getElementById("e-"+elementId+"-text").style.display="none";
	document.getElementById("e-"+elementId+"-edit").style.display="inline";
	document.getElementById("e-"+elementId+"-editrotateobj").style.display="inline";

	if (wheelId>0) {document.getElementById("e-"+elementId+"-wheel"+wheelId).style.background=visu_indiColor;}

	createWheel(document.getElementById("e-"+elementId+"-wheel0"),document.getElementById("e-"+elementId+"-editrotateobj"),0);

	//Startwerte (je nach gewählten Wheel)
	if (d.dataset.var1==0) { //Dimmer
		if (d.dataset.value && d.dataset.value>=0 && d.dataset.value<=255) {
			d.dataset.editvalue=d.dataset.value;
		} else {
			d.dataset.editvalue=0;
		}
	}
	if (d.dataset.var1==1) { //RGB-Dimmer
		var rgb=RGBHEXtoRGB(d.dataset.value);
		if (rgb!==false) {
			if (wheelId==0) { //Helligkeit (V)
				var hsv=RGBHEXtoHSV(d.dataset.value);
				if (hsv!==false) {
					d.dataset.editvalue=hsv[2];
				} else {
					d.dataset.editvalue=0;
				}
			}
			if (wheelId==1) {d.dataset.editvalue=rgb[0];} //R
			if (wheelId==2) {d.dataset.editvalue=rgb[1];} //G
			if (wheelId==3) {d.dataset.editvalue=rgb[2];} //B
			d.dataset.edithsv=d.dataset.value;
		} else {
			d.dataset.editvalue=0;
			d.dataset.edithsv="000000";
		}
	}
	if (d.dataset.var1==2) { //HSV-Dimmer
		var hsv=HSVHEXtoHSV(d.dataset.value);
		if (hsv!==false) {
			if (wheelId==0) {d.dataset.editvalue=hsv[2];} //V
			if (wheelId==1) {d.dataset.editvalue=hsv[0];} //H
			if (wheelId==2) {d.dataset.editvalue=hsv[1];} //S
			d.dataset.edithsv=d.dataset.value;
		} else {
			d.dataset.editvalue=0;
			d.dataset.edithsv="000000";
		}
	}

	d.dataset.wheelid=wheelId;
	d.dataset.oldangle=-1;
	control12_Move();

	window.addEventListener(moveEvent,control12_Move,false);
	window.addEventListener(upEvent,control12_Send,false);

	if (visu_allowScrolling) {
		//Scrolling temporär verhindern
		window.addEventListener(moveEvent,disableScrolling,false);
	}

}

function control12_Move() {
	if (!event) var event=window.event;
	if (elementDragId>0) {
		var d=document.getElementById("e-"+elementDragId);
		if (d && d.dataset.controltyp==12) {
			var x1=parseInt(document.getElementById("windowContainer").offsetLeft+d.offsetLeft+(d.offsetWidth/2))+parseInt(d.dataset.pagex); //Mittelpunkt des Elements
			var y1=parseInt(document.getElementById("windowContainer").offsetTop+d.offsetTop+(d.offsetHeight/2))+parseInt(d.dataset.pagey);
			var x2=getPageX(event);
			var y2=getPageY(event);

			var angle=(360-((Math.atan2(x2-x1,y2-y1)*180/Math.PI)+180)).toFixed(0);
			var anglepercent=(angle/3.6).toFixed(0);

			if (d.dataset.var1==0) { //Dimmer
				if (d.dataset.oldangle>=0) {
					var step=(anglepercent-parseInt(d.dataset.oldangle));
					if (Math.abs(step)>50) {step=0;}
					d.dataset.editvalue=parseFloat(d.dataset.editvalue)+(step*1);
					if (parseFloat(d.dataset.editvalue)<0) {d.dataset.editvalue=0;}
					if (parseFloat(d.dataset.editvalue)>255) {d.dataset.editvalue=255;}
				}
				var color=Math.round(d.dataset.editvalue) & 255;
				document.getElementById("e-"+elementDragId+"-editrotateobj").style.background="#"+RGBtoRGBHEX(color,color,color);
				document.getElementById("e-"+elementDragId+"-edit").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+(d.dataset.editvalue/2.55).toFixed(1)+" %</span></button>";
			}

			if (d.dataset.var1==1) { //RGB-Dimmer
				if (d.dataset.oldangle>=0) {
					var step=(anglepercent-parseInt(d.dataset.oldangle));
					if (Math.abs(step)>50) {step=0;}
					d.dataset.editvalue=parseFloat(d.dataset.editvalue)+(step*1);
					if (parseFloat(d.dataset.editvalue)<0) {d.dataset.editvalue=0;}
					if (parseFloat(d.dataset.editvalue)>255) {d.dataset.editvalue=255;}
					var rgb=RGBHEXtoRGB(d.dataset.edithsv);
					if (d.dataset.wheelid==1) {d.dataset.edithsv=RGBtoRGBHEX(d.dataset.editvalue,rgb[1],rgb[2]);}
					if (d.dataset.wheelid==2) {d.dataset.edithsv=RGBtoRGBHEX(rgb[0],d.dataset.editvalue,rgb[2]);}
					if (d.dataset.wheelid==3) {d.dataset.edithsv=RGBtoRGBHEX(rgb[0],rgb[1],d.dataset.editvalue);}
					if (d.dataset.wheelid==0) { //Sonderfall: Helligkeit (V)
						var hsv=RGBHEXtoHSV(d.dataset.edithsv);
						if (hsv!==false) {
							d.dataset.edithsv=HSVtoRGBHEX(hsv[0],hsv[1],d.dataset.editvalue);
						}
					}
				}
				document.getElementById("e-"+elementDragId+"-editrotateobj").style.background="#"+d.dataset.edithsv;
				if (d.dataset.wheelid>=0) {document.getElementById("e-"+elementDragId+"-edit").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+(d.dataset.editvalue/2.55).toFixed(1)+" %</span></button>";}
			}

			if (d.dataset.var1==2) { //HSV-Dimmer
				if (d.dataset.oldangle>=0) {
					var step=(anglepercent-parseInt(d.dataset.oldangle));
					if (Math.abs(step)>50) {step=0;}
					d.dataset.editvalue=parseFloat(d.dataset.editvalue)+(step*1);
					if (parseFloat(d.dataset.editvalue)<0) {d.dataset.editvalue=0;}
					if (parseFloat(d.dataset.editvalue)>255) {d.dataset.editvalue=255;}
					var hsv=HSVHEXtoHSV(d.dataset.edithsv);
					if (d.dataset.wheelid==0) {d.dataset.edithsv=HSVtoHSVHEX(hsv[0],hsv[1],d.dataset.editvalue);}
					if (d.dataset.wheelid==1) {d.dataset.edithsv=HSVtoHSVHEX(d.dataset.editvalue,hsv[1],hsv[2]);}
					if (d.dataset.wheelid==2) {d.dataset.edithsv=HSVtoHSVHEX(hsv[0],d.dataset.editvalue,hsv[2]);}
				}

				document.getElementById("e-"+elementDragId+"-editrotateobj").style.background="#"+HSVHEXtoRGBHEX(d.dataset.edithsv);
				if (d.dataset.wheelid==0) {document.getElementById("e-"+elementDragId+"-edit").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+(d.dataset.editvalue/2.55).toFixed(1)+" %</span></button>";}
				if (d.dataset.wheelid==1) {document.getElementById("e-"+elementDragId+"-edit").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+(d.dataset.editvalue*(360/255)).toFixed(0)+" &deg;</span></button>";}
				if (d.dataset.wheelid==2) {document.getElementById("e-"+elementDragId+"-edit").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+(d.dataset.editvalue/2.55).toFixed(1)+" %</span></button>";}
			}

			document.getElementById("e-"+elementDragId+"-editrotateobj").style.WebkitTransform="rotate("+angle+"deg)";
			d.dataset.oldangle=anglepercent;
		}
	}
}

function control12_Send() {
	var d=document.getElementById("e-"+elementDragId);
	if (d && d.dataset.controltyp==12) {

		if (d.dataset.var1==0) { //Dimmer
			var newValue=d.dataset.editvalue;
		}
		if (d.dataset.var1==1) { //RGB-Dimmer
			var newValue=d.dataset.edithsv;
		}
		if (d.dataset.var1==2) { //HSV-Dimmer
			var newValue=d.dataset.edithsv;
		}

		if (newValue) {
			var setKoMode=d.dataset.var4;
			var setKoChanged=false;
			if ((d.dataset.value+"x").toUpperCase()!==(newValue+"x").toUpperCase()) {setKoChanged=true;}
			if ((setKoMode==0) || (setKoMode==1 && setKoChanged) || (setKoMode==2) || (setKoMode==3 && setKoChanged)) {
				if ((setKoMode==2) || (setKoMode==3 && setKoChanged)) {
					d.dataset.blocked=0;
				} else {
					d.dataset.blocked=1;
					document.getElementById("e-"+elementDragId+"-text").innerHTML="<div class='sendValueAnim'>"+document.getElementById("e-"+elementDragId+"-edit").innerHTML+"</div>";
				}
				setKoValue(d.dataset.gaid2,newValue);
			}
		}

		document.getElementById("e-"+elementDragId+"-text").style.display="inline";
		document.getElementById("e-"+elementDragId+"-edit").style.display="none";
		
		if (document.getElementById("e-"+elementDragId+"-wheel1")) {document.getElementById("e-"+elementDragId+"-wheel1").style.background="inherit";}
		if (document.getElementById("e-"+elementDragId+"-wheel2")) {document.getElementById("e-"+elementDragId+"-wheel2").style.background="inherit";}
		if (document.getElementById("e-"+elementDragId+"-wheel3")) {document.getElementById("e-"+elementDragId+"-wheel3").style.background="inherit";}
		document.getElementById("e-"+elementDragId+"-editrotateobj").style.display="none";

		elementDragId=0;
		window.removeEventListener(moveEvent,control12_Move,false);
		window.removeEventListener(upEvent,control12_Send,false);

		if (visu_allowScrolling) {
			//Scrolling wieder freigeben
			window.removeEventListener(moveEvent,disableScrolling,false);
		}

	}
}

function control12_Switch(elementId,value) {
	if (!event) var event=window.event;
	var d=document.getElementById("e-"+elementId);
	if (d.dataset.blocked==1) {return;}

	if (value==0) {
		showShortClickItem(document.getElementById("e-"+elementId+"-off"));

		if (d.dataset.var1==0) {var newValue="0";}
		if (d.dataset.var1==1) {var newValue="000000";}
		if (d.dataset.var1==2) {
			var hsv=HSVHEXtoHSV(d.dataset.value);
			if (hsv!==false) {var newValue=HSVtoHSVHEX(hsv[0],hsv[1],0);} else {var newValue="000000";}
		}
		
		if (newValue) {
			var setKoMode=d.dataset.var4;
			var setKoChanged=false;
			if ((d.dataset.value+"x").toUpperCase()!==(newValue+"x").toUpperCase()) {setKoChanged=true;}
			if ((setKoMode==0) || (setKoMode==1 && setKoChanged) || (setKoMode==2) || (setKoMode==3 && setKoChanged)) {
				if ((setKoMode==2) || (setKoMode==3 && setKoChanged)) {
					d.dataset.blocked=0;
				} else {
					d.dataset.blocked=1;
					document.getElementById("e-"+elementId+"-text").innerHTML="<div class='sendValueAnim'><button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>AUS</span></button></div>";
					document.getElementById("e-"+elementId+"-text").style.display="inline";
				}
				setKoValue(d.dataset.gaid2,newValue);
			}
		}
		
	}
	if (value==1) {
		showShortClickItem(document.getElementById("e-"+elementId+"-on"));
		if (d.dataset.var1==0) {var newValue="255";}
		//if (d.dataset.var1==1) {var newValue="ffffff";} //es gibt keinen Button hierfür...
		if (d.dataset.var1==2) {
			var hsv=HSVHEXtoHSV(d.dataset.value);
			if (hsv!==false) {var newValue=HSVtoHSVHEX(hsv[0],hsv[1],255);} else {var newValue="ffffff";}
		}

		if (newValue) {
			var setKoMode=d.dataset.var4;
			var setKoChanged=false;
			if ((d.dataset.value+"x").toUpperCase()!==(newValue+"x").toUpperCase()) {setKoChanged=true;}
			if ((setKoMode==0) || (setKoMode==1 && setKoChanged) || (setKoMode==2) || (setKoMode==3 && setKoChanged)) {
				if ((setKoMode==2) || (setKoMode==3 && setKoChanged)) {
					d.dataset.blocked=0;
				} else {
					d.dataset.blocked=1;
					document.getElementById("e-"+elementId+"-text").innerHTML="<div class='sendValueAnim'><button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>EIN</span></button></div>";
					document.getElementById("e-"+elementId+"-text").style.display="inline";
				}
				setKoValue(d.dataset.gaid2,newValue);
			}
		}

	}	
}
